<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE  mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="com.engine.salary.mapper.auth.AuthResourceMapper">
    <resultMap id="BaseResultMap" type="com.engine.salary.entity.auth.po.AuthResourcePO">
        <result column="create_time" property="createTime" />
        <result column="creator" property="creator" />
        <result column="delete_type" property="deleteType" />
        <result column="id" property="id" />
        <result column="role_id" property="roleId" />
        <result column="target" property="target" />
        <result column="target_name" property="targetName" />
        <result column="target_type" property="targetType" />
        <result column="tenant_key" property="tenantKey" />
        <result column="update_time" property="updateTime" />
    </resultMap>

    <!-- 表字段 -->
    <sql id="baseColumns">
        t.create_time
        , t.creator
        , t.delete_type
        , t.id
        , t.role_id
        , t.target
        , t.target_name
        , t.target_type
        , t.tenant_key
        , t.update_time
    </sql>

    <!-- 查询全部 -->
    <select id="listAll" resultMap="BaseResultMap">
        SELECT
        <include refid="baseColumns" />
        FROM hrsa_auth_resource t
        WHERE delete_type = 0
    </select>

    <!-- 根据主键获取单条记录 -->
    <select id="getById" resultMap="BaseResultMap" parameterType="Long">
        SELECT
        <include refid="baseColumns" />
        FROM hrsa_auth_resource t
        WHERE id = #{id} AND delete_type = 0
    </select>

    <!-- 条件查询 -->
    <select id="listSome" resultMap="BaseResultMap" parameterType="com.engine.salary.entity.auth.po.AuthResourcePO">
        SELECT
        <include refid="baseColumns" />
        FROM hrsa_auth_resource t
        WHERE delete_type = 0
        <if test="createTime != null">
            AND create_time = #{createTime}
        </if>
        <if test="creator != null">
            AND creator = #{creator}
        </if>
        <if test="deleteType != null">
            AND delete_type = #{deleteType}
        </if>
        <if test="id != null">
            AND id = #{id}
        </if>
        <if test="roleId != null">
            AND role_id = #{roleId}
        </if>
        <if test="target != null">
            AND target = #{target}
        </if>
        <if test="targetName != null">
            AND target_name = #{targetName}
        </if>
        <if test="targetType != null">
            AND target_type = #{targetType}
        </if>
        <if test="tenantKey != null">
            AND tenant_key = #{tenantKey}
        </if>
        <if test="updateTime != null">
            AND update_time = #{updateTime}
        </if>
        <if test="ids != null and ids.size()>0">
            AND id IN
            <foreach collection="ids" open="(" item="id" separator="," close=")">
                #{id}
            </foreach>
        </if>
        ORDER BY id DESC
    </select>


    <!-- 插入不为NULL的字段 -->
    <insert id="insertIgnoreNull" parameterType="com.engine.salary.entity.auth.po.AuthResourcePO">
        INSERT INTO hrsa_auth_resource
        <trim prefix="(" suffix=")" suffixOverrides=",">

            <if test="createTime != null">
                create_time,
            </if>
            <if test="creator != null">
                creator,
            </if>
            <if test="deleteType != null">
                delete_type,
            </if>
            <if test="id != null">
                id,
            </if>
            <if test="roleId != null">
                role_id,
            </if>
            <if test="target != null">
                target,
            </if>
            <if test="targetName != null">
                target_name,
            </if>
            <if test="targetType != null">
                target_type,
            </if>
            <if test="tenantKey != null">
                tenant_key,
            </if>
            <if test="updateTime != null">
                update_time,
            </if>
        </trim>
        <trim prefix="VALUES (" suffix=")" suffixOverrides=",">
            <if test="createTime != null" >
                #{createTime},
            </if>
            <if test="creator != null" >
                #{creator},
            </if>
            <if test="deleteType != null" >
                #{deleteType},
            </if>
            <if test="id != null" >
                #{id},
            </if>
            <if test="roleId != null" >
                #{roleId},
            </if>
            <if test="target != null" >
                #{target},
            </if>
            <if test="targetName != null" >
                #{targetName},
            </if>
            <if test="targetType != null" >
                #{targetType},
            </if>
            <if test="tenantKey != null" >
                #{tenantKey},
            </if>
            <if test="updateTime != null" >
                #{updateTime},
            </if>
        </trim>
    </insert>

    <!-- 更新,更新全部字段 -->
    <update id="update" parameterType="com.engine.salary.entity.auth.po.AuthResourcePO">
        UPDATE hrsa_auth_resource
        <set>
            create_time=#{createTime},
            creator=#{creator},
            delete_type=#{deleteType},
            role_id=#{roleId},
            target=#{target},
            target_name=#{targetName},
            target_type=#{targetType},
            tenant_key=#{tenantKey},
            update_time=#{updateTime},
        </set>
        WHERE id = #{id} AND delete_type = 0
    </update>


    <!-- 更新不为NULL的字段 -->
    <update id="updateIgnoreNull" parameterType="com.engine.salary.entity.auth.po.AuthResourcePO">
        UPDATE hrsa_auth_resource
        <set>
            <if test="createTime != null" >
                create_time=#{createTime},
            </if>
            <if test="creator != null" >
                creator=#{creator},
            </if>
            <if test="deleteType != null" >
                delete_type=#{deleteType},
            </if>
            <if test="roleId != null" >
                role_id=#{roleId},
            </if>
            <if test="target != null" >
                target=#{target},
            </if>
            <if test="targetName != null" >
                target_name=#{targetName},
            </if>
            <if test="targetType != null" >
                target_type=#{targetType},
            </if>
            <if test="tenantKey != null" >
                tenant_key=#{tenantKey},
            </if>
            <if test="updateTime != null" >
                update_time=#{updateTime},
            </if>
        </set>
        WHERE id = #{id} AND delete_type = 0
    </update>


    <!-- 根据主键删除记录 -->
    <delete id="delete">
        UPDATE hrsa_auth_resource
        SET delete_type=1
        WHERE id = #{id} AND delete_type = 0
    </delete>

    <delete id="deleteByIds">
        UPDATE hrsa_auth_resource
        SET delete_type = 1
        WHERE  delete_type = 0
        AND id IN
        <foreach collection="ids" open="(" item="id" separator="," close=")">
            #{id}
        </foreach>
    </delete>
    
    
    <delete id="deleteByRoleId">
        UPDATE hrsa_auth_resource
        SET delete_type = 1
        WHERE delete_type = 0
          AND role_id=#{roleId}
    </delete>


</mapper>